> For the complete documentation index, see [llms.txt](https://docs.orai.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.orai.io/developer-guides/oraichainevm/smart-contracts/address.md).

# Address

Oraichain supports two types of addresses: the EVM address (0x...) for the Ethereum Virtual Machine (EVM) side and the Bech32 address (orai...) for the Cosmos side. The [Address](https://github.com/oraidex/evm-entry-point/blob/main/packages/contracts/contracts/precompiles/IAddr.sol) precompiled contract enables users to retrieve the association between these two address formats.&#x20;

## Solidity Interfaces

* getCosmosAddr

Get the associated Cosmos Address (orai...) by providing EVM address (0x...)

```
function getCosmosAddr(
        address addr
    ) external view returns (string memory response);
```

* getEvmAddr

Get the associated EVM address (0x...) by providing Cosmos Address (orai...)

```
function getEvmAddr(
        string memory addr
    ) external view returns (address response);
```

* associate

Get the associated EVM address and Cosmos Address by message signature components

```
function associate(
        string memory v,
        string memory r,
        string memory s,
        string memory customMessage
    ) external returns (string memory cosmosAddr, address evmAddr);
```

* associatePubKey

Get the associated EVM address and Cosmos Address by pubkey

```
function associatePubKey(
        string memory pubKeyHex
    ) external returns (string memory cosmosAddr, address evmAddr);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.orai.io/developer-guides/oraichainevm/smart-contracts/address.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
